unit veremu;

interface
uses telemu;

Type
     TMutato=^TVerem;

     Tverem=record
        ertek:Telem;
        mutato:TMutato;
     end;

     Verem=class

        Private

          teteje:TMutato;
          hiba:boolean;

        Public

          constructor create;
          destructor destroy;
          procedure ures;
          function ures_e:boolean;
          function hibas_e:boolean;
          function tele_e:boolean;
          procedure verembol(var e:Telem);
          procedure verembe(e: Telem);
          procedure kiiras;
          procedure teto(var tet:Telem);

     end;


implementation

     constructor verem.create;
        begin
        teteje:=nil;
        hiba:=false;
        end;

     destructor verem.destroy;
     var sv,sv2:TMutato;
     begin
     sv:=teteje;
        while sv<>nil do
                     begin
                     sv2:=sv;
                     sv:=sv^.mutato;
                     dispose(sv2);
                     end;
     end;

     procedure verem.ures;
               begin
               teteje:=nil;
               hiba:=false;
               end;

     function verem.ures_e:boolean;
              begin
              ures_e:=(teteje=nil);
              end;

     function verem.hibas_e:boolean;
              begin
              hibas_e:=hiba;
              hiba:=false;
              end;

     function verem.tele_e:boolean;
              begin
              tele_e:=false;
              //tele_e:=(Maxavail=sizeof(Telem));
              end;

     procedure verem.verembol(var e:Telem);
     var seged:Tmutato;
               begin
               if ures_e then hiba:=true else
                  begin
                    e:=teteje^.ertek;
                    seged:=teteje^.mutato;
                    dispose(teteje);
                    teteje:=seged;
                  end;
               end;

     procedure verem.verembe(e:Telem);
     var uj:Tmutato;
               begin
               if tele_e then hiba:=true
                  else begin
                       new(uj);
                       uj^.mutato:=teteje;
                       uj^.ertek:=e;
                       teteje:=uj;
                       end;
               end;

     procedure verem.teto(var tet:Telem);
              begin
              if ures_e then hiba:=true else
                 begin
                 tet:=teteje^.ertek;
                 end;
              end;

     procedure verem.kiiras;
     var sv:TMutato;
               begin
               sv:=teteje;
               while sv<>nil do
                     begin
                     {write(sv^.ertek,' ');}
                     sv:=sv^.mutato;
                     end;
               end;


begin
end.